/* GCC */
#include <set>
#include <queue>
#include <math.h>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>

#define pb push_back
#define mp make_pair
#define F first
#define S second
#define Ri(a) scanf("%d", &(a))
#define Ri2(a,b) scanf("%d%d", &(a), &(b))
#define Wi(a) printf("%d ", a)
#define Wi2(a,b) printf("%d %d ", a, b)
#define Wie(a) printf("%d\n", a)
#define Wie2(a,b) printf("%d %d\n", a, b)
#define pii pair<int,int>
#define FOR(i,a,b) for( int i = (a), _n_ = (b); i <= _n_; i++ )
#define FORD(i,a,b) for( int i = (a), _n_ = (b); i >= _n_; i-- )
#define forn(i,n) FOR(i,0,(n) - 1)

using namespace std;

int m, n;
vector < vector < int > > gr;
queue < pii > q;

int main() {
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);
    
    pii end;
    char c;
    Ri2( m, n );
    gr.resize( m );
    
    c = getchar();
    forn( i, m ) {
          gr[i].resize(n);
          forn( j, n ) {
                c = getchar();
                switch( c ) {
                        case '+': gr[i][j] = '+', q.push( mp( i, j ) ), end = mp( i, j );
                        break;
                        
                        case ' ': gr[i][j] = 0;
                        break;
                        
                        default: gr[i][j] = '#';
                }
          }
          c = getchar();
    }
    
    int sz;
    pii pos;
    while(1) {
           sz = q.size();
           if( sz == 0 ) break;
           forn( i, sz ) {
                 pos = q.front();
                 q.pop();
                 
                 if( pos.F == 0 || pos.F == m - 1 || pos.S == 0 || pos.S == n - 1 ) goto ex;
                 
                 if( pos.F > 0 && gr[pos.F - 1][pos.S] == 0 ) {
                     gr[pos.F - 1][pos.S] = 'n';
                     q.push( mp( pos.F - 1, pos.S ) );
                 }
                 if( pos.F + 1 < m && gr[pos.F + 1][pos.S] == 0 ) {
                     gr[pos.F + 1][pos.S] = 's';
                     q.push( mp( pos.F + 1, pos.S ) );
                 }
                 if( pos.S > 0 && gr[pos.F][pos.S - 1] == 0 ) {
                     gr[pos.F][pos.S - 1] = 'w';
                     q.push( mp( pos.F, pos.S - 1 ) );
                 }
                 if( pos.S + 1 < n && gr[pos.F][pos.S + 1] == 0 ) {
                     gr[pos.F][pos.S + 1] = 'e';
                     q.push( mp( pos.F, pos.S + 1 ) );
                 }
           }  
    }
    
    Wie(-1);
    
    fclose(stdin);
    fclose(stdout);
    return 0;
    
    ex:;
    
    vector <int> ans;
    while( pos != end ) {
           switch( gr[pos.F][pos.S] ) {
                   case 'n': ans.pb( 'n' ), pos.F++;
                   break;
                   
                   case 's': ans.pb( 's' ), pos.F--;
                   break;
                   
                   case 'w': ans.pb( 'w' ), pos.S++;
                   break;
                   
                   default: ans.pb('e'), pos.S--;
           }
    }
    Wie( ans.size() );
    FORD( i, ans.size() - 1, 0 ) putchar( ans[i] );
    if(ans.size() != 0) putchar('\n');
    
    fclose(stdin);
    fclose(stdout);
    return 0;
}
